/*********************************************************************
  All ADuC7023 library code provided by ADI, including this file, is provided
 as is without warranty of any kind, either expressed or implied.
 You assume any and all risk from the use of this code.  It is the
 responsibility of the person integrating this code into an application
 to ensure that the resulting application performs as required and is safe.

 Author        : ADI - Apps            www.analog.com/ADuC7023

 Date          : February 2009

 File          : ADC.c

 Hardware      : Applicable to ADuC7023 rev A later silicon
                 
 Description   : Simple test to check ADC functionality
 				Connect output of DAC0 to ADC0 channel
		
*********************************************************************/
#include <aduc7023.h>
unsigned int uiPLLTST = 0;
volatile unsigned int ucTest = 0;

void ADCpoweron(int);
int main(void) 
{
	unsigned short ADCDATA[32];
	int i;
	
	POWKEY1 = 0x01;					// Configure CPU Clock for 41.78MHz, CD=0
 	POWCON = 0x00;
 	POWKEY2 = 0xF4;	

	GP0DAT = 0x80000000;			// Set P0.7 as LED output
	
	DAC0CON = 0x13;					// Set DAC0 output to 0-AVDD range and turn DAC0 on
	DAC0DAT = 0x04000000;			// start from midscale

	ADCpoweron(20000);				// power on ADC
	ADCCP = 0x00;	  				// select ADC channel 0
	REFCON = 0x01;					// internal 2.5V reference. 2.5V on Vref pin
	ADCCON = 0xEE4;					// ADC Config: fADC/8, acq. time = 8 clocks 
	while (1) 
	{
		GP0DAT ^= 0x00800000;		// Complement P0.7
									// start continuous conversion
		for (i=0; i <32; i++) 
		{
		while (!ADCSTA){}			// wait for end of conversion
		ADCDATA[i] = (ADCDAT >> 16);
		}
		GP0DAT ^= 0x00800000;		// Complement P0.7
	}				
}

void ADCpoweron(int time)
{
	ADCCON = 0x20;	 					// power-on the ADC
	while (time >=0)	  				// wait for ADC to be fully powered on
    time--;
}
